#include<stdio.h>
#include "all.h"
#include<math.h>
#include<time.h>
#include<stdlib.h>
#include "extall.h"

#define I 0
#define SIZE 40
#define LOSIZE 0 /*no of leave out sites*/
#define T 1
#define REPS 400
#define N 25000
#define M 5000
#define C 5
/***************funtion prototypes**************/

double sqr (double x);
double min(double x,double y);
/*random variates*/
double uni_ran();
double gam_ran(double a,double be);
double nor_ran(double u, double s);


/*matrices*/
double trace(double *a, int p);
void add_mat(double *a, double *b, int n, int m, double *c);
void sub_mat(double *a, double *b, int n, int m, double *c);
double xtAy(double *x,double *A,double *y,int p);
void trans_pose (double *a,double *b, int m, int n);
void tinv_mat (double *t,double *c,int p);
void inv_mat(double *S,double *inv,int p,double *det);
void sq_rt(double *a ,double *t ,int p ,double *det);
void mat_mul(double *ma1,double *ma2,double *mul,
double no,double po,double qo );
void scalar_mult(double s, double *x, int n, int m, double *ot);

/**********************************************/

int main (void){
  int i,j,k,l,r;

  float u;
char s[22];
/*ins*/
FILE *data;
FILE *leave_out_data;
FILE *coord;
FILE *leave_out_coord;
/*outs*/
FILE *par_output;
FILE *par_estimates;
FILE *pred_output;
FILE *pred_estimates;
FILE *pred_error;

double all_z[REPS*SIZE*T]={0};
double z[SIZE*T]={0};
double xcoord[SIZE]={0};
double ycoord[SIZE]={0};

/* leave out a one time point*/
double all_leave_out_z[REPS*LOSIZE*I];
double leave_out_z[LOSIZE*I];
double leave_out_xcoord[LOSIZE*I];
double leave_out_ycoord[LOSIZE*I];


/*R:write.table(data,file="data.txt", row.names=FALSE)
make sure no row names*/

 data = fopen("../data_files/dataS.txt", "r");
 fscanf(data, "%s\n",s); /* do not read the header */
 for (i=0; i<REPS*SIZE*T; i++) {
   fscanf(data, "%g", &u);
   all_z[i] = u;
    }
 fclose(data);


 coord = fopen("../data_files/coordS.txt", "r");
 fscanf(coord, "%s %s\n",s, s); /* do not read the header */
 for (i=0; i<SIZE; i++) {
   fscanf(coord, "%g", &u);  /* latitude */
   xcoord[i] = u;
   fscanf(coord, "%g", &u);  /* latitude */
   ycoord[i] = u;
 }
 fclose(coord);

 if(I>0){
 leave_out_data = fopen("../data_files/leave_out_data.txt", "r");
 fscanf(leave_out_data, "%s\n",s); /* do not read the header */
 for (i=0; i<REPS*LOSIZE*I; i++) {
   fscanf(leave_out_data, "%g", &u);
   all_leave_out_z[i] = u;
    }
 fclose(leave_out_data);

 leave_out_coord = fopen("../data_files/leave_out_coord.txt", "r");
 fscanf(leave_out_coord, "%s %s\n", s, s); /* do not read the header */
 for (i=0; i<LOSIZE*I; i++) {
   fscanf(leave_out_coord, "%g", &u);  /* latitude */
   leave_out_xcoord[i] = u;
   fscanf(leave_out_coord, "%g", &u);  /* latitude */
   leave_out_ycoord[i] = u;
 }
 fclose(leave_out_coord);
 }
/*checked: files read in correctly*/


 double dist[SIZE*SIZE]={0};
    for (i=0;i<SIZE;i++){
      for(j=0;j<SIZE;j++){
                dist[i*SIZE+j]=sqrt(sqr(xcoord[i]-xcoord[j])
                                 +sqr(ycoord[i]-ycoord[j])) ;
                         }
                        }

/*nXp matrix, columns have dist between s' and other sites*/
double dist_0[SIZE*LOSIZE*I];
for (i=0;i<SIZE;i++){
   for(l=0;l<LOSIZE*I;l++){
            dist_0[i*LOSIZE*I+l]=sqrt(sqr(xcoord[i]-leave_out_xcoord[l])
                               +sqr(ycoord[i]-leave_out_ycoord[l])) ;
                        }
                      }

double time[T*T];
for (i=0;i<T;i++){
   for(j=0;j<T;j++){
       time[i*T+j]=fabs(i-j);
                    }
                      }


 double one[SIZE*T]={0};
 for(i=0;i<SIZE*T;i++){one[i]=1;}

/*empty vectors for covariate*parameter*/
 double xione[SIZE*T]={0};
 double z_xi_0[SIZE*T]={0};
/*sums for parameter estimates*/
 double sum_xi_0;
  /*store estmates for each rep*/
 double xi_0_hat[REPS]={0};

 /*xi_0 and beta_0*/
 double var_xi;
 double sd_xi;
 double mean_xi;

 double sum_tWSigInvW;
 double sum_tIminusWIminusW;

 /*relating to w_s*/
 double det;
 double stdnorm[SIZE*T]={0};
 double norm[SIZE*T]={0};
 double Hphi_w_s[SIZE*SIZE]={0};
 double Hphi_w_t[T*T]={0};
 double Hphi_w_sInv[SIZE*SIZE]={0};
 double Hphi_w_tInv[T*T]={0};
 double Sigma_wInv[SIZE*T*SIZE*T]={0};
 double S_wInvxi[SIZE*T]={0};
 double z_w[SIZE*T]={0};
 double tauIdz_w[SIZE*T]={0};
 double mean_w[SIZE*T]={0};
 double sd_w[SIZE*T*SIZE*T]={0};

 double w_s_centred[SIZE*T]={0};

  /*relating to phi*/

 double detHphi_w_s;
 double detHphi_w_t;


/*prediction vectors*/
double S21_w[SIZE*T]={0};
double w_s_0;


double z_0[(N-M)*LOSIZE*I];
double sum_z_0[LOSIZE*I];
double z_0_hat[LOSIZE*I];
double store_z_0_hat[REPS*LOSIZE*I];

/*prediction error*/
double sumSE;
double sumAE;
double MSE;
double MAE;

double crps[LOSIZE*I]; /*1 value for each site*/

double diff[LOSIZE*I];
double cross_diff[LOSIZE*I];
double CRPS;/*one value for each rep, mean of crps*/

double store_MAE[REPS]={0};
double store_MSE[REPS]={0};
double store_CRPS[REPS]={0};

/*hyperparameters*/
 int  xi_m=0;
 int  v_xi_0=pow(10,4);


/*variable names, start values */
 double W[SIZE*T*SIZE*T]={0};
 double IminusW[SIZE*T*SIZE*T]={0};
 double tW[SIZE*T*SIZE*T]={0};
 double tIminusW[SIZE*T*SIZE*T]={0};
 double Store[SIZE*T*SIZE*T]={0};
 double storevec[SIZE*T]={0};

 clock_t begin, end;
 double time_spent;

/*vectors for variables*/
 double xi_0[N];
 double w_s[SIZE*T];
 double tausq_w=1;
 double tausq_e;
 double phi_w_s;
 double phi_w_t=1;

 double start_xi_0[C]={8,-4,7,-9,6};
 /*
 double start_xi_0[C]={0};
*/

int c;
for(c=0;c<C;c++){
 xi_0[0]=start_xi_0[c];





srand(1234);
/* srand(time( NULL )); */
 begin=clock();


for(r=0;r<REPS;r++){

/*recall that sigma.sq=1/tausq*/
if(r<80){
tausq_e=0.01;
} else if(r<160){
tausq_e=0.1;
} else if (r<240){
tausq_e=1;
} else if (r<320){
tausq_e=10;
} else if (r<400){
tausq_e=100;
}
if(r<20){
phi_w_s=100;
} else if(r<40){
phi_w_s=-log(0.05)/(sqrt(2)/3);
} else if(r<60){
phi_w_s=-log(0.05)/(2*sqrt(2)/3);
} else if (r<80){
phi_w_s=-log(0.05)/(3*sqrt(2)/3);
} else if(r<100){
phi_w_s=100;
} else if(r<120){
phi_w_s=-log(0.05)/(sqrt(2)/3);
} else if(r<140){
phi_w_s=-log(0.05)/(2*sqrt(2)/3);
} else if (r<160){
phi_w_s=-log(0.05)/(3*sqrt(2)/3);
} else if(r<180){
phi_w_s=100;
} else if(r<200){
phi_w_s=-log(0.05)/(sqrt(2)/3);
} else if(r<220){
phi_w_s=-log(0.05)/(2*sqrt(2)/3);
} else if (r<240){
phi_w_s=-log(0.05)/(3*sqrt(2)/3);
} else if(r<260){
phi_w_s=100;
} else if(r<280){
phi_w_s=-log(0.05)/(sqrt(2)/3);
} else if(r<300){
phi_w_s=-log(0.05)/(2*sqrt(2)/3);
} else if (r<320){
phi_w_s=-log(0.05)/(3*sqrt(2)/3);
} else if(r<340){
phi_w_s=100;
} else if(r<360){
phi_w_s=-log(0.05)/(sqrt(2)/3);
} else if(r<380){
phi_w_s=-log(0.05)/(2*sqrt(2)/3);
} else if (r<400){
phi_w_s=-log(0.05)/(3*sqrt(2)/3);
}



/*reset correlation matrices*/
for(i=0;i<SIZE*SIZE;i++){
      Hphi_w_s[i]=0;
}

for(i=0;i<T*T;i++){
          Hphi_w_t[i]=0;
			}

/*reset counters strat of each rep*/
sum_xi_0=0;

sumSE=0;
sumAE=0;
CRPS=0;

for(l=0;l<LOSIZE*I;l++){
sum_z_0[l]=0;
crps[l]=0;
diff[l]=0;
cross_diff[l]=0;
}

/*read in data for this rep(checked)*/
for(i=0;i<SIZE*T;i++){
z[i]=all_z[r*SIZE*T+i];}

for(i=0;i<LOSIZE*I;i++){
leave_out_z[i]=all_leave_out_z[r*LOSIZE*I+i];
}

if(phi_w_s==100){
for(i=0;i<SIZE;i++){Hphi_w_s[i*SIZE+i]=1;}
for(i=0;i<T;i++){Hphi_w_t[i*T+i]= 1;}
}
else{
for(i=0;i<SIZE;i++){
    for(j=0;j<SIZE;j++){
      Hphi_w_s[i*SIZE+j]= exp(-(phi_w_s*dist[i*SIZE+j]));
			}}

for(i=0;i<T;i++){
    for(j=0;j<T;j++){
      Hphi_w_t[i*T+j]= exp(-(phi_w_t*time[i*T+j]));
			}}
}

inv_mat(Hphi_w_s,Hphi_w_sInv,SIZE,&detHphi_w_s);
inv_mat(Hphi_w_t,Hphi_w_tInv,T,&detHphi_w_t);

scalar_mult(tausq_w,Hphi_w_sInv,SIZE*T,SIZE*T,Sigma_wInv);

/*compute W and I-W*/

for(i=0;i<SIZE;i++){
    for(j=0;j<SIZE;j++){
      W[i*SIZE+j]= Sigma_wInv[i*SIZE+j];
			}}
/*add nugget*/

for(i=0;i<SIZE*T;i++){
      W[i*SIZE*T+i]=Sigma_wInv[i*SIZE*T+i]+tausq_e;
                     }
/*invert*/
  inv_mat(W,W,SIZE*T,&det);
/*multiply by C^{-1}_{2}*/
 mat_mul(W,Sigma_wInv,IminusW,SIZE*T,SIZE*T,SIZE*T);

 /*multiply by -1*/
 scalar_mult(-1,IminusW,SIZE*T,SIZE*T,W);
 /*add identity*/
 for(i=0;i<SIZE;i++){W[i*SIZE+i]=W[i*SIZE+i]+1;}

 trans_pose(W,tW,SIZE*T,SIZE*T);
 trans_pose(IminusW,tIminusW,SIZE*T,SIZE*T);

mat_mul(tIminusW,IminusW,Store,SIZE*T,SIZE*T,SIZE*T);

sum_tIminusWIminusW=0;
   for(i=0;i<SIZE*T;i++){
     for(j=0;j<SIZE*T;j++){
              sum_tIminusWIminusW+=Store[i*SIZE*T+j];
                        }}

mat_mul(tW,Sigma_wInv,Store,SIZE*T,SIZE*T,SIZE*T);
mat_mul(Store,W,tW,SIZE*T,SIZE*T,SIZE*T);

sum_tWSigInvW=0;
for(i=0;i<SIZE*T;i++){
     for(j=0;j<SIZE*T;j++){
              sum_tWSigInvW+=tW[i*SIZE*T+j];
                        }}

   var_xi=1.0/(
(tausq_w/v_xi_0)+(tausq_e*sum_tIminusWIminusW)+sum_tWSigInvW
);
 sd_xi=sqrt(var_xi);

 trans_pose(W,tW,SIZE*T,SIZE*T);


/*######################################################*/
  /*sampler*/
 for(k=1;k<N;k++){


/*centering data,z_w= z-1xi_0+Wxi_0*/
  scalar_mult(xi_0[k-1],one,SIZE*T,1,xione);
  sub_mat(z,xione,SIZE*T,1,z_w);
  mat_mul(W,xione,storevec,SIZE*T,SIZE*T,1);/*!!!! */
  add_mat(z_w,storevec,SIZE*T,1,z_w);

  for(i=0;i<SIZE*T;i++){
     tauIdz_w[i]=tausq_e*z_w[i];
                       }
  mat_mul(Sigma_wInv,storevec,S_wInvxi,SIZE*T,SIZE*T,1);/*from ! storevec=Wtheta01*/
  add_mat(tauIdz_w,S_wInvxi,SIZE*T,1,tauIdz_w);

/*keep using Sigma_wInv to store var*/
for(i=0;i<SIZE*T;i++){
      Sigma_wInv[i*SIZE*T+i]=Sigma_wInv[i*SIZE*T+i]+tausq_e;
                     }

  inv_mat(Sigma_wInv,Sigma_wInv,SIZE*T,&det);

  mat_mul(Sigma_wInv,tauIdz_w,mean_w,SIZE*T,SIZE*T,1);

   sq_rt(Sigma_wInv,sd_w,SIZE*T,&det);
   for(i=0;i<SIZE*T;i++){ stdnorm[i]=nor_ran(0,1);}
   mat_mul(sd_w,stdnorm,norm,SIZE*T,SIZE*T,1);
   add_mat(mean_w,norm,SIZE*T,1,w_s);
/*
for(i=0;i<SIZE*T;i++){
w_s[i]=0;
}
*/

scalar_mult(tausq_w,Hphi_w_sInv,SIZE*T,SIZE*T,Sigma_wInv);
/*#######################################*/

/*xi_0[k]=2;*/


/*centering data,z_xi_0= z-w*/

   sub_mat(z,w_s,SIZE*T,1,z_xi_0);

mat_mul(W,one,storevec,SIZE*T,SIZE*T,1);

mean_xi=var_xi*(xi_m*tausq_w/v_xi_0+
	tausq_e*xtAy(one,tIminusW,z_xi_0,SIZE*T)+
xtAy(storevec,Sigma_wInv,w_s,SIZE*T));

   xi_0[k]=nor_ran(mean_xi,sd_xi);
/*
xi_0[k]=6;
*/



/*#######################################*/

/*#######################################*/

/*****************************************/

/*####################################*/
/*update matrices*/


/*#######################################*/
/*z_0 has (N-m)*LOSIZE elements, the kth draw for the lth site is element k*LOSIZE+l*/

if(k>(N)){


 for(l=0;l<LOSIZE;l++){

   for(i=0;i<SIZE;i++){
    for(j=0;j<T;j++){

   S21_w[i*T+j]=(1.0/tausq_w)*exp(-phi_w_s*dist_0[i*LOSIZE+l]
                                     -phi_w_t*(T-j) );
                    }
                   }



   w_s_0=nor_ran(xtAy(S21_w,Sigma_wInv,w_s_centred,SIZE*T),
   sqrt((1.0/tausq_w)-xtAy(S21_w,Sigma_wInv,S21_w,SIZE*T)));


   z_0[((k-M)*LOSIZE)+l]=nor_ran(xi_0[k]+w_s_0,pow(tausq_e,-0.5));

                }/*end l loop*/
            }/*end if*/


/*Z_0=(N-m)xLOSIZE matrix, each column is a leave out site*/


/***************************************/
  } /*end k loop*/


/*estimates*/
for (i=M;i<N;i++){
sum_xi_0=sum_xi_0+xi_0[i];

}


/*store parameter estimates*/
xi_0_hat[r]=sum_xi_0/(N-M);




/*each entry has the sum
of the draws from post.pred dist for each LO site*/
for(l=0;l<LOSIZE;l++){
for(i=0;i<(N-M);i++){
sum_z_0[l]+=z_0[i*LOSIZE+l];
                     }
                    }

/*estimate for z_0's*/
for(l=0;l<LOSIZE;l++){
z_0_hat[l]=(1.0/(N-M))*sum_z_0[l];
                     }

/*store REPS*LOSIZE z_0_hat*/
for(l=0;l<LOSIZE;l++){
store_z_0_hat[r*LOSIZE+l]=z_0_hat[l];
                     }


/*********prediction error*********/

for(l=0;l<LOSIZE;l++){
      sumSE+=sqr((leave_out_z[l]-z_0_hat[l]));
                     }
MSE=(1.0/LOSIZE)*sumSE;

for(l=0;l<LOSIZE;l++){
       sumAE+=fabs(leave_out_z[l]-(z_0_hat[l]));
                     }
MAE=(1.0/LOSIZE)*sumAE;

/*first term in crps*/
for(l=0;l<LOSIZE;l++){
    for(i=0;i<(N-M);i++){
diff[l]+=fabs(z_0[i*LOSIZE+l]-leave_out_z[l]);
                         }
diff[l]=(1.0/(N-M))*diff[l];
                     }

/*second term in crps, average of cross differences*/

for(l=0;l<LOSIZE;l++){
  for(j=0;j<(N-M);j++){
    for(k=0;k<(N-M);k++){
cross_diff[l]+=fabs(z_0[j*LOSIZE+l]-z_0[k*LOSIZE+l]) ;
                        }
                      }
cross_diff[l]=(1.0/(2*sqr(N-M)))*cross_diff[l];
                     }


for(l=0;l<LOSIZE;l++){
crps[l]=diff[l]-cross_diff[l];
}

for(l=0;l<LOSIZE;l++){
CRPS+=(1.0/(LOSIZE))*crps[l];}


store_MAE[r]=MAE;
store_MSE[r]=MSE;
store_CRPS[r]=CRPS;

if(c==0){
par_output = fopen("../data_files/par_output_f01_partS.txt", "a+");
} else if(c==1){
par_output = fopen("../data_files/par_output_f02_partS.txt", "a+");
} else if (c==2){
par_output = fopen("../data_files/par_output_f03_partS.txt", "a+");
} else if (c==3){
par_output = fopen("../data_files/par_output_f04_partS.txt", "a+");
} else if (c==4){
par_output = fopen("../data_files/par_output_f05_partS.txt", "a+");
}


 for(i=0;i<N;i++){
     fprintf(par_output, "%f\n", xi_0[i]);
   }

 fclose(par_output);


pred_output = fopen("../data_files/pred_output_f0_partS.txt", "a+");

 for(i=0;i<((N-M)*LOSIZE);i++){
     fprintf(pred_output, "%f\n", z_0[i]);
   }

 fclose(pred_output);



}/*end r loop*/
end = clock();


time_spent = (double)(end - begin) / CLOCKS_PER_SEC;
/*printf("time: %.2f\n",time_spent);
printf("\n");

printf("xi_0hat:");
for(r=0;r<REPS;r++){
printf(" %f, ",xi_0_hat[r]);}
printf("\n");


for(r=0;r<REPS;r++){
printf("%f, %f, %f, \n",store_MAE[r],store_MSE[r],store_CRPS[r] );
}
*/


par_estimates = fopen("../data_files/par_est_f0_partS.txt", "w");

 for(i=0;i<REPS;i++){
     fprintf(par_estimates , "%f \n", xi_0_hat[i]);
   }

 fclose(par_estimates);


pred_estimates = fopen("../data_files/pred_est_f0_partS.txt", "w");

 for(i=0;i<(REPS*LOSIZE);i++){
     fprintf(pred_estimates, "%f \n", store_z_0_hat[i]);
   }

 fclose(pred_estimates);



pred_error = fopen("../data_files/pred_error_f0_partS.txt", "w");

 for(i=0;i<REPS;i++){
     fprintf(pred_error, "%f %f %f \n", store_MAE[i],store_MSE[i],
             store_CRPS[i]);
   }

 fclose(pred_error);



}/*close C loop*/
 return 0;
  }


/**********body of functions**************/

double min(double x,double y){
  double min=x;
  if (y<x){
    min=y;}
  return min;
  	 }

double sqr( x )
double x;
{
  return x * x;
}
/*random variates*/

/*uniform*/
double uni_ran()
{
 return ((double)rand() + 0.5)/((double)RAND_MAX + 1.0);
}

double nor_ran( u, s )
double u; double s;
{
  double t;
  t = sqrt( -2.0 * log( drand48()) )
 * cos( 2.0 * M_PI * drand48() );
  return u + s * t;
}

/* Berger's Gamma */
double gam_ran( a, be)
double a; double be;
{
  double b, c, w, u, v, x, z, y;
  int acc;                  /*  true = 1, false = 0 */
  double s,s1;

 if ( a<=1.0 )
 {
  s1 = gam_ran ( a + 1.0 , be );
  s = drand48();
  s =  pow ( s , 1.0 / a );
  s = s * s1;
 return s;
 }
 else
 {

  b = a-1.0; c = 3.0 * a - (3.0/4.0); acc = 0;
     do
     {
       u = drand48(); v = drand48();
       w = u * (1.0-u); y = sqrt(c/w) * (u-0.5); x = b+y;
       if (x >  0.0)
  {
      z = 64.0 * sqr(w) * w * sqr(v);
      if ( z < (1.0 - 2.0 * sqr(y) / x) )
        { acc = 1; }
      else if (log(z) < 2.0 * (b * log( x / b) - y))
       { acc = 1; }
  }
      } while( acc == 0 );

   return  x * be;

}

}


/*matrices*/


double trace(double *a, int p){
int i;  double u=0.0;

for (i=0; i<p; i++)
     u +=a[i*p+i];
return (u);
}

void add_mat(double *a, double *b, int n, int m, double *c) {
  int i, j;

  for (i=0; i<n; i++) {
      for (j=0; j<m; j++)
	c[i*m+j] = a[i*m+j]  + b[i*m+j];

}
}


void sub_mat(double *a, double *b, int n, int m, double *c) {
  int i, j;

  for (i=0; i<n; i++) {
      for (j=0; j<m; j++)
	c[i*m+j] = a[i*m+j]  - b[i*m+j];

}
}

double xtAy(x, A, y, p)
double *x;
double *A;
double *y;
int p;
{
 double u=0.0;
 int i, j;

 for (i=0; i<p; i++) {
   for (j=0; j<p; j++) {
     u +=x[i] * A[i*p+j] * y[j];
   }
 }
 return u;
 }


void trans_pose ( a, b, m, n )
double *a;
double *b;
int m;
int n;

{
 int i , j;

 for ( i = 0 ; i < m ; i++)
 {
  for ( j = 0 ; j < n ; j ++)
    {  b[j * m  + i]  = a[i * n  + j] ; }
  }

}


void tinv_mat ( t, c, p)
double *t;
double *c;
int p;

{
int i , j , k;
double u;

   for ( i = 0; i <p ; i++)
       {
         for ( j = 0;  j < p ; j++)
         c[i * p  + j] = 0.0;
       }

  for ( i = 0 ; i < p ; i++)
  c[i * p  + i] = 1.0 / t[i * p  + i];

 if ( p > 1) {
  c[p] = -t[p]* c[0]/ t[p + 1];

 for ( i=2 ; i <p ; i ++)
 {
  for ( j = 0 ; j < p-1  ; j ++)
  {
     if ( j < i ) {
      u = 0.0 ;
      for ( k = j ; k < i ; k++)
      u = u + t[i * p  + k] * c[k * p  + j];
      c[i * p  + j] = - u / t[i * p  + i];
     }
   }
 }
} /*  p  > 1 loop */

}



void inv_mat(S, inv, p, det)
double *S;
double *inv;
int p;
double *det;

{

double *t1; double *t; double u;

t1 =(double*)malloc(sizeof(double)*p*p);
t = (double*)malloc(sizeof(double)*p*p);

  sq_rt( S, t , p , &u);
  *det = u;
  tinv_mat( t , t1 , p);
  trans_pose(t1, t, p , p);
  mat_mul(t, t1, inv , p+0.0 , p+0.0 , p+0.0);
  *det = u;

free(t1);
free(t);
}



void sq_rt( a , t ,  p , det)
double *a;
double *t;
int     p;
double *det;

{

 int i , j , k ;
 double sum, sum1, u, v;

  for ( i = 0 ; i < p ; i ++)
      {
       for ( j = 0 ; j <p ; j++)
       t[i*p +j] = 0.0 ;
      }


  t[0] = sqrt(a[0]);
 if ( p > 1 ) {

  v = exp(-25.0);
  t[p] = a[p] / t[0];
  u =  a[p+1]  - sqr(t[p] );
  if  ( u<v ) {
         printf("Exited from sqrt: Matrix not pd\n");
         exit(19);
   } else  t[p+1] = sqrt(u);

  for (i=2 ; i<p ; i++)
    {
      t[i*p] =  a[i*p] /  t[0] ;
      for (j=1; j < p - 1 ; j++)
          {
            if ( j < i ) {
            sum1 = 0.0 ;
            for (k=0; k < j ; k++)
            sum1 += t[i*p + k] *  t[j*p + k];
            t[i*p+j] = (a[i*p + j]  - sum1) / t[j*p + j];
            }
          }

      sum = 0.0 ;
      for ( k = 0 ; k < i ; k ++)
      sum += sqr( t[i*p  + k] );
      u = a[i*p+i] - sum;
         if ( u<v ) {
                    printf("Exited from sqrt: Matrix not PD\n");
                    exit(19);
         } else  t[i*p+i] = sqrt(u);
    }

 } /* If loop for p > 1 */
 *det = 1.0 ;
 for ( i = 0 ; i < p ; i++)
 *det = *det * sqr( t[i*p + i] );

}

void mat_mul( ma1, ma2, mul, no, po, qo )
double *ma1; double *ma2; double *mul; double no; double po; double qo;
{



  int i, j, k, n, p, q;

  n = no; p = po; q = qo;

   for( i=0; i < n; i++)
   {
      for( j=0; j < q; j++)
      {  *(mul + i * q + j) = 0.0;   }
   }
   for( i=0; i < n; i++)
   {
       for( j=0; j < q; j++)
       {
           for( k=0; k < p; k++)
             *(mul + i * q + j) = *(mul + i * q + j) + *(ma1 + i * p + k) *
*(ma2 + k * q + j);
       }
   }
}


void scalar_mult(double s, double *x, int n, int m, double *ot)
{
  int i, j;

for (i=0; i<n; i++) {
  for (j=0; j<m; j++)
	ot[i*m+j] = x[i*m+j] * s;
}
}


