#include<stdio.h>
#include "all.h"
#include<math.h>
#include<time.h>
#include<stdlib.h>
#include "extall.h"

#define I 0
#define SIZE 47
#define LOSIZE 0 /*no of leave out sites*/
#define T 1
#define REPS 1
#define N 25000
#define M 5000
#define C 5
/***************funtion prototypes**************/

double sqr (double x);
double min(double x,double y);
/*random variates*/
double uni_ran();
double gam_ran(double a,double be);
double nor_ran(double u, double s);


/*matrices*/
double trace(double *a, int p);
void add_mat(double *a, double *b, int n, int m, double *c);
void sub_mat(double *a, double *b, int n, int m, double *c);
double xtAy(double *x,double *A,double *y,int p);
void trans_pose (double *a,double *b, int m, int n);
void tinv_mat (double *t,double *c,int p);
void inv_mat(double *S,double *inv,int p,double *det);
void sq_rt(double *a ,double *t ,int p ,double *det);
void mat_mul(double *ma1,double *ma2,double *mul,
double no,double po,double qo );
void scalar_mult(double s, double *x, int n, int m, double *ot);
double ludcmp(double *a, int n, int *indx, double *d);
/**********************************************/

int main (void){
  int i,j,k,l,r;

  float u;
char s[22];
/*ins*/
FILE *data;
FILE *covariate;
FILE *leave_out_data;
FILE *leave_out_covariate;
/*FILE *coord;
FILE *leave_out_coord;*/
FILE *geodist;
FILE *geodist_val;

/*outs*/
FILE *par_output;
FILE *par_estimates;
FILE *pred_output;
FILE *pred_estimates;
FILE *pred_error;

double* dist_0;
double* dist;

dist_0=(double*)malloc(SIZE*LOSIZE*I*sizeof(double));
dist=(double*)malloc(SIZE*SIZE*sizeof(double));

double all_z[SIZE*T]={0};
double z[SIZE*T]={0};
double x[SIZE*T]={0};
/*double xcoord[SIZE]={0};
double ycoord[SIZE]={0};
*/
/* leave out a one time point*/
double all_leave_out_z[LOSIZE*I];
double leave_out_z[LOSIZE*I];
double leave_out_x[LOSIZE*I];
/*
double leave_out_xcoord[LOSIZE*I];
double leave_out_ycoord[LOSIZE*I];
*/

/*R:write.table(data,file="data.txt", row.names=FALSE)
make sure no row names*/

 data = fopen("data.txt", "r");
 fscanf(data, "%s\n",s); /* do not read the header */
 for (i=0; i<SIZE*T; i++) {
   fscanf(data, "%g", &u);
   all_z[i] = u;
    }
 fclose(data);

 covariate = fopen("covariate.txt", "r");
 fscanf(covariate, "%s\n", s); /* do not read the header */
 for (i=0; i<SIZE*T; i++) {
   fscanf(covariate, "%g", &u); /* covariate  */
   x[i] = u;
     }
 fclose(covariate);

 /*
 coord = fopen("coord.txt", "r");
 fscanf(coord, "%s %s\n",s, s);
 for (i=0; i<SIZE; i++) {
   fscanf(coord, "%g", &u);
   xcoord[i] = u;
   fscanf(coord, "%g", &u);
   ycoord[i] = u;
 }
 fclose(coord);

 */
 leave_out_data = fopen("leave_out_data.txt", "r");
 fscanf(leave_out_data, "%s\n",s);
 for (i=0; i<LOSIZE*I; i++) {
   fscanf(leave_out_data, "%g", &u);
   all_leave_out_z[i] = u;
    }
 fclose(leave_out_data);



 leave_out_covariate = fopen("leave_out_covariate.txt", "r");
 fscanf(leave_out_covariate, "%s\n",s);
 for (i=0; i<LOSIZE*I; i++) {
   fscanf(leave_out_covariate, "%g", &u);
   leave_out_x[i] = u;
    }
 fclose(leave_out_covariate);

 /*

 leave_out_coord = fopen("leave_out_coord.txt", "r");
 fscanf(leave_out_coord, "%s %s\n", s, s);
 for (i=0; i<LOSIZE*I; i++) {
   fscanf(leave_out_coord, "%g", &u);
   leave_out_xcoord[i] = u;
   fscanf(leave_out_coord, "%g", &u);
   leave_out_ycoord[i] = u;
 }
 fclose(leave_out_coord);
 */
 /*
 double dist[SIZE*SIZE]={0};
    for (i=0;i<SIZE;i++){
      for(j=0;j<SIZE;j++){
                dist[i*SIZE+j]=sqrt(sqr(xcoord[i]-xcoord[j])
                                 +sqr(ycoord[i]-ycoord[j])) ;
                         }
                        }
*/


geodist = fopen("geodist.txt", "r");
fscanf(geodist,"%s\n",s);
for(i=0;i<SIZE*SIZE;i++){
	 fscanf(geodist,"%g",&u);
	 dist[i]=u;
}
fclose(geodist);


/*nXp matrix, columns have dist between s' and other sites
double dist_0[SIZE*LOSIZE*I];
for (i=0;i<SIZE;i++){
   for(l=0;l<LOSIZE*I;l++){
            dist_0[i*LOSIZE*I+l]=sqrt(sqr(xcoord[i]-leave_out_xcoord[l])
                               +sqr(ycoord[i]-leave_out_ycoord[l])) ;
                        }
                      }
*/

geodist_val = fopen("geodist_val.txt", "r");
fscanf(geodist_val,"%s\n",s);
for(i=0;i<SIZE*LOSIZE*I;i++){
	 fscanf(geodist_val,"%g",&u);
	 dist_0[i]=u;
}
fclose(geodist_val);



double time[T*T];
for (i=0;i<T;i++){
   for(j=0;j<T;j++){
       time[i*T+j]=fabs(i-j);
                    }
                      }

/*
 double one[SIZE*T]={0};
 for(i=0;i<SIZE*T;i++){one[i]=1;}
 */



/*sums for parameter estimates*/
 double sum_xi_0;
 double sum_beta_0;
 double sum_tausq_w;
 double sum_tausq_beta;
 double sum_tausq_e;

/*store estmates for each rep*/
 double xi_0_hat[REPS]={0};
 double beta_0_hat[REPS]={0};
 double tausq_w_hat[REPS]={0};
 double tausq_beta_hat[REPS]={0};
 double tausq_e_hat[REPS]={0};



/*relating to beta*/
double all_beta[2*SIZE];
double* S;
double* C2X1t;
double* X1C2;
double* twonbynStore;
double* twonby2nStore;
double* C2;
double* B;
double* W;
double* IminusW;
double b[2*SIZE];

double mean_Beta[2*SIZE*T]={0};
double* sd_Beta;
double stdnorm[2*SIZE*T]={0};
double norm[2*SIZE*T]={0};

S=(double*)malloc(SIZE*T*SIZE*T*sizeof(double));
C2X1t=(double*)malloc(2*SIZE*T*SIZE*T*sizeof(double));
X1C2=(double*)malloc(2*SIZE*T*SIZE*T*sizeof(double));
C2=(double*)malloc(4*SIZE*T*SIZE*T*sizeof(double));
B=(double*)malloc(4*SIZE*T*SIZE*T*sizeof(double));
sd_Beta=(double*)malloc(4*SIZE*T*SIZE*T*sizeof(double));
twonby2nStore=(double*)malloc(4*SIZE*T*SIZE*T*sizeof(double));
twonbynStore=(double*)malloc(2*SIZE*T*SIZE*T*sizeof(double));
W=(double*)malloc(4*SIZE*T*SIZE*T*sizeof(double));
IminusW=(double*)malloc(4*SIZE*T*SIZE*T*sizeof(double));

/*matrices relating to beta.s*/
 double det;
 double detHphi_beta_s;
 double detHphi_beta_t;
 double* Hphi_beta_s;
 double Hphi_beta_t[T*T]={0};
 double* Hphi_beta_sInv;
 double Hphi_beta_tInv[T*T]={0};


Hphi_beta_s=(double*)malloc(SIZE*SIZE*sizeof(double));
Hphi_beta_sInv=(double*)malloc(SIZE*SIZE*sizeof(double));



 /*relating to w_s*/
double detHphi_w_s;
 double detHphi_w_t;
 double* Hphi_w_s;
 double Hphi_w_t[T*T]={0};
 double* Hphi_w_sInv;
 double Hphi_w_tInv[T*T]={0};

Hphi_w_s=(double*)malloc(SIZE*SIZE*sizeof(double));
Hphi_w_sInv=(double*)malloc(SIZE*SIZE*sizeof(double));

/*relating to theta*/


double X1ImWX2[SIZE*2];
double tX1ImWX2[2*SIZE];
double C2WX2[2*SIZE*2];
double WX2[2*SIZE*2];
double tWX2[2*2*SIZE];
double tWX2C2WX2[2*2];





double sumHphi_w_sInv;
double sumHphi_beta_sInv;

double theta[2];
double Vartheta[2*2];
double sd_theta[2*2];
double bTheta[2];
double stdnormtheta[2];
double normtheta[2];
double mean_theta[2];


 /*relating to precision parameters*/
 double nbyTstore1[SIZE*T]={0};
 double Tbynstore1[T*SIZE]={0};
 double TbyTstore1[T*T]={0};
 double nbyTstore2[SIZE*T]={0};
 double Tbynstore2[T*SIZE]={0};
 double wtHphi_wInvw;
 double betatHphi_betaInvbeta;
 double shape_w;
 double rate_w;
 double shape_beta;
 double rate_beta;
 double shape_e;
 double rate_e;
 double sum_z_musq;
 double z_mu[SIZE];
 double w_s_centred[SIZE*T]={0};
 double beta_s_centred[SIZE*T]={0};
/* double xione[SIZE*T]={0};
 double betaone[SIZE*T]={0};*/

 double rowsum1;
 double rowsum2;
 double rowsum3;
 double rowsum4;
/*prediction vectors*/
double S21_w[SIZE*T]={0};
double w_s_0;
double S21_beta[SIZE*T]={0};
double beta_s_0;

double z_0[(N-M)*LOSIZE*I];
double sum_z_0[LOSIZE*I];
double z_0_hat[LOSIZE*I];
double store_z_0_hat[REPS*LOSIZE*I];

/*prediction error*/
double sumSE;
double sumAE;
double MSE;
double MAE;

double crps[LOSIZE*I]; /*1 value for each site*/

double diff[LOSIZE*I];
double cross_diff[LOSIZE*I];
double CRPS;/*one value for each rep, mean of crps*/

double store_MAE[REPS]={0};
double store_MSE[REPS]={0};
double store_CRPS[REPS]={0};


 /*hyperparameters*/
 int  xi_m=0;
 int  v0Inv=0.0001;
 int  beta_m=0;
 int  v1Inv=0.0001;
 int  a_w=2;
 int  b_w=1;
 int  a_beta=2;
 int  b_beta=1;
 int  a_e=2;
 int  b_e=1;


 clock_t begin, end;
 double time_spent;


/*vectors for variables*//*
 double xi_0[N];
 double beta_0[N];
 double beta_s[SIZE*T];
 double w_s[SIZE*T];
 double tausq_w[N];
 double tausq_beta[N];
 double tausq_e[N];
 */
 double* xi_0;
 double* beta_0;
 double* beta_s;
 double* w_s;
 double* tausq_w;
 double* tausq_beta;
 double* tausq_e;
 double sigmasq_w;
 double sigmasq_beta;
 double sigmasq_e;

 double phi_w_s;
 double phi_beta_s;
 double phi_w_t=1;
 double phi_beta_t=1;

xi_0=(double*)malloc(N*sizeof(double));
beta_0=(double*)malloc(N*sizeof(double));
beta_s=(double*)malloc(SIZE*T*sizeof(double));
w_s=(double*)malloc(SIZE*T*sizeof(double));
tausq_w=(double*)malloc(N*sizeof(double));
tausq_beta=(double*)malloc(N*sizeof(double));
tausq_e=(double*)malloc(N*sizeof(double));


double start_xi_0[C]={8,2,10,0,12};
 double start_beta_0[C]={-5,5,-4,3,-2};
 double start_tausq_w[C]={1,10,3,12,5};
 double start_tausq_beta[C]={12,2,9,6,11};
 double start_tausq_e[C]={14,6,1,8,10};

/*
 double start_xi_0[C]={8};
 double start_beta_0[C]={0};
 double start_tausq_w[C]={1};
 double start_tausq_beta[C]={3};
 double start_tausq_e[C]={3};
*/

int c;
for(c=0;c<C;c++){
 xi_0[0]=start_xi_0[c];
 beta_0[0]=start_beta_0[c];
 tausq_w[0]=start_tausq_w[c];
 tausq_beta[0]=start_tausq_beta[c];
 tausq_e[0]=start_tausq_e[c];


srand(1234);
 /*srand(time( NULL ));*/
 begin=clock();


for(r=0;r<REPS;r++){

if(r<5){
phi_w_s=-log(0.05)/5;
} else if(r<10){
phi_w_s=-log(0.05)/100;
} else if(r<15){
phi_w_s=-log(0.05)/250;
} else if (r<20){
phi_w_s=-log(0.05)/500;
} else if (r<25){
phi_w_s=-log(0.05)/1000;
}

if(r%5==0){
phi_beta_s=-log(0.05)/100;
} else if(r%5==1){
phi_beta_s=-log(0.05)/100;
} else if(r%5==2){
phi_beta_s=-log(0.05)/250;
} else if (r%5==3){
phi_beta_s=-log(0.05)/500;
} else if (r%5==4){
phi_beta_s=-log(0.05)/1000;
}



sigmasq_w=1/tausq_w[0];
sigmasq_beta=1/tausq_beta[0];
sigmasq_e=1/tausq_e[0];
/*reset counters strat of each rep*/
sum_xi_0=0;
sum_beta_0=0;
sum_tausq_w=0;
sum_tausq_beta=0;
sum_tausq_e=0;

sumSE=0;
sumAE=0;
CRPS=0;

for(l=0;l<LOSIZE*I;l++){
sum_z_0[l]=0;
crps[l]=0;
diff[l]=0;
cross_diff[l]=0;
}

/*read in data for this rep(checked)*/
for(i=0;i<SIZE*T;i++){
z[i]=all_z[i];}

for(i=0;i<LOSIZE*I;i++){
leave_out_z[i]=all_leave_out_z[i];
}

for(i=0;i<SIZE;i++){
    for(j=0;j<SIZE;j++){
      Hphi_w_s[i*SIZE+j]= exp(-(phi_w_s*dist[i*SIZE+j]));
			}}

for(i=0;i<SIZE;i++){
    for(j=0;j<SIZE;j++){
      Hphi_beta_s[i*SIZE+j]= exp(-(phi_beta_s*dist[i*SIZE+j]));
			}}

for(i=0;i<T;i++){
    for(j=0;j<T;j++){
      Hphi_w_t[i*T+j]= exp(-(phi_w_t*time[i*T+j]));
			}}


for(i=0;i<T;i++){
    for(j=0;j<T;j++){
      Hphi_beta_t[i*T+j]= exp(-(phi_beta_t*time[i*T+j]));
			}}

inv_mat(Hphi_w_s,Hphi_w_sInv,SIZE,&detHphi_w_s);
inv_mat(Hphi_w_t,Hphi_w_tInv,T,&detHphi_w_t);
inv_mat(Hphi_beta_s,Hphi_beta_sInv,SIZE,&detHphi_beta_s);
inv_mat(Hphi_beta_t,Hphi_beta_tInv,T,&detHphi_beta_t);


sumHphi_w_sInv=0;
sumHphi_beta_sInv=0;

for(i=0;i<SIZE*SIZE;i++){
      sumHphi_w_sInv=sumHphi_w_sInv+Hphi_w_sInv[i];
                     }

for(i=0;i<SIZE*SIZE;i++){
      sumHphi_beta_sInv=sumHphi_beta_sInv+Hphi_beta_sInv[i];
                     }


for(i=0;i<SIZE;i++){
w_s[i]=0;
beta_s[i]=0;
}

  /*sampler*/
 for(k=1;k<N;k++){
/*All betas*/
for(i=0;i<SIZE;i++){
for(j=0;j<SIZE;j++){
	S[i*SIZE+j]=sigmasq_w*Hphi_w_s[i*SIZE+j]+
		        (sigmasq_beta*x[i]*Hphi_beta_s[i*SIZE+j]*x[j]);
}}

for(i=0;i<SIZE;i++){
	S[i*SIZE+i]=S[i*SIZE+i]+sigmasq_e;
}


inv_mat(S,S,SIZE,&det);


for(i=0;i<SIZE;i++){
for(j=0;j<SIZE;j++){
C2X1t[i*SIZE+j]=sigmasq_w*Hphi_w_s[i*SIZE+j];
}}

for(i=SIZE;i<2*SIZE;i++){
for(j=0;j<SIZE;j++){
C2X1t[i*SIZE+j]=sigmasq_beta*Hphi_beta_s[(i-SIZE)*SIZE+j]*x[j];
}}

trans_pose(C2X1t,X1C2,2*SIZE,SIZE);


for(i=0;i<SIZE;i++){
for(j=0;j<SIZE;j++){
 C2[i*SIZE*2+j]=sigmasq_w*Hphi_w_s[i*SIZE+j];
}}

for(i=SIZE;i<2*SIZE;i++){
for(j=SIZE;j<2*SIZE;j++){
 C2[i*SIZE*2+j]=sigmasq_beta*Hphi_beta_s[((i-SIZE)*SIZE)+(j-SIZE)];
}}


mat_mul(C2X1t,S,twonbynStore,2*SIZE*T,SIZE*T,SIZE*T);

for(i=0;i<2*SIZE;i++){
for(j=0;j<SIZE;j++){
W[i*SIZE*2+j]=twonbynStore[i*SIZE+j];
 }}

for(i=0;i<2*SIZE;i++){
for(j=SIZE;j<2*SIZE;j++){
W[i*SIZE*2+j]=twonbynStore[i*SIZE+(j-SIZE)]*x[(j-SIZE)];
 }}




 /*multiply by -1*/
 scalar_mult(-1,W,2*SIZE*T,2*SIZE*T,IminusW);
 /*add identity*/
 for(i=0;i<2*SIZE;i++){IminusW[i*SIZE*2+i]=IminusW[i*SIZE*2+i]+1;}


mat_mul(twonbynStore,X1C2,twonby2nStore,2*SIZE*T,SIZE*T,2*SIZE);
sub_mat(C2,twonby2nStore,2*SIZE*T,2*SIZE*T,B);

/*non-centred portion X1C1^-1(y-X1(I-W)X2theta*/
for(i=0;i<2*SIZE;i++){
	b[i]=0;    }

rowsum1=0; rowsum2=0;rowsum3=0;rowsum4=0;
for(i=0;i<SIZE;i++){
	for(j=0;j<SIZE;j++){
rowsum1=rowsum1+IminusW[i*SIZE*2+j];
rowsum2=rowsum2+IminusW[i*SIZE*2+(j+SIZE)];
rowsum3=rowsum3+IminusW[(i+SIZE)*2*SIZE+j];
rowsum4=rowsum4+IminusW[(i+SIZE)*2*SIZE+(SIZE+j)];
	}
	b[i]=z[i]-rowsum1*xi_0[k-1]-rowsum2*beta_0[k-1]
	     -x[i]*rowsum3*xi_0[k-1]-x[i]*rowsum4*beta_0[k-1];

b[i+SIZE]=x[i]*(z[i]-rowsum1*xi_0[k-1]-rowsum2*beta_0[k-1]
	     -x[i]*rowsum3*xi_0[k-1]-x[i]*rowsum4*beta_0[k-1]);
		 rowsum1=0; rowsum2=0;rowsum3=0;rowsum4=0;
}


scalar_mult(tausq_e[k-1],b,2*SIZE*T,1,b);

rowsum1=0;rowsum2=0;
for(i=0;i<SIZE;i++){
for(j=0;j<SIZE;j++){
	rowsum1=rowsum1+S[i*SIZE+j];
    rowsum2=rowsum2+S[i*SIZE+j]*x[j];
	}
b[i]=b[i]+rowsum1*xi_0[k-1]+rowsum2*beta_0[k-1];
b[i+SIZE]=b[i+SIZE]+(x[i]*rowsum1*xi_0[k-1]+x[i]*rowsum2*beta_0[k-1]);

rowsum1=0; rowsum2=0;
}

mat_mul(B,b,mean_Beta,2*SIZE*T,2*SIZE*T,1);

   sq_rt(B,sd_Beta,2*SIZE*T,&det);
   for(i=0;i<2*SIZE*T;i++){ stdnorm[i]=nor_ran(0,1);}
   mat_mul(sd_Beta,stdnorm,norm,2*SIZE*T,2*SIZE*T,1);
   add_mat(mean_Beta,norm,2*SIZE*T,1,all_beta);




for(i=0;i<SIZE;i++){
w_s[i]=all_beta[i];
beta_s[i]=all_beta[i+SIZE];
}
/*
for(i=0;i<SIZE;i++){
w_s[i]=8.5;
beta_s[i]=.05;
}*/

/*######################################*/

/*theta*/

for(i=0;i<SIZE*2;i++){
	X1ImWX2[i]=0;
}

rowsum1=0;rowsum2=0;rowsum3=0;rowsum4=0;
for(i=0;i<SIZE;i++){
	for(j=0;j<SIZE;j++){
		rowsum1=rowsum1+IminusW[i*SIZE*2+j];
		rowsum2=rowsum2+IminusW[(i+SIZE)*SIZE*2+j];
		rowsum3=rowsum3+IminusW[i*SIZE*2+(j+SIZE)];
		rowsum4=rowsum4+IminusW[(i+SIZE)*2*SIZE+(j+SIZE)];
	}
X1ImWX2[i*2]=rowsum1+x[i]*rowsum2;
X1ImWX2[i*2+1]=rowsum3+x[i]*rowsum4;

rowsum1=0;rowsum2=0;rowsum3=0;rowsum4=0;
}

trans_pose(X1ImWX2,tX1ImWX2,SIZE,2);
mat_mul(tX1ImWX2,X1ImWX2,Vartheta,2,SIZE,2);
scalar_mult(tausq_e[k-1],Vartheta,2,2,Vartheta);

for(i=0;i<SIZE*4;i++){
C2WX2[i]=0;
}

rowsum1=0;rowsum2=0;
for(i=0;i<SIZE;i++){
	for(j=0;j<SIZE;j++){
rowsum1=rowsum1+S[i*SIZE+j];
rowsum2=rowsum2+S[i*SIZE+j]*x[j];
	}
C2WX2[i*2]=rowsum1;
C2WX2[i*2+1]=rowsum2;
C2WX2[(i+SIZE)*2]=x[i]*rowsum1;
C2WX2[(i+SIZE)*2+1]=x[i]*rowsum2;
rowsum1=0;rowsum2=0;
	}


for(i=0;i<SIZE*4;i++){
WX2[i]=0;
}

rowsum1=0;rowsum2=0;rowsum3=0;rowsum4=0;
for(i=0;i<SIZE;i++){
	for(j=0;j<SIZE;j++){
	rowsum1=rowsum1+W[i*SIZE*2+j];
	rowsum2=rowsum2+W[i*SIZE*2+(SIZE+j)];
	rowsum3=rowsum3+W[(i+SIZE)*2*SIZE+j];
	rowsum4=rowsum4+W[(i+SIZE)*2*SIZE+(j+SIZE)];
}
WX2[i*2]=rowsum1;
WX2[i*2+1]=rowsum2;
WX2[(i+SIZE)*2]=rowsum3;
WX2[(i+SIZE)*2+1]=rowsum4;
rowsum1=0;rowsum2=0;rowsum3=0;rowsum4=0;
	}

trans_pose(WX2,tWX2,2*SIZE,2);

mat_mul(tWX2,C2WX2,tWX2C2WX2,2,2*SIZE,2);

add_mat(Vartheta,tWX2C2WX2,2,2,Vartheta);

Vartheta[0]=Vartheta[0]+tausq_w[k-1]*v0Inv;
Vartheta[3]=Vartheta[3]+tausq_beta[k-1]*v1Inv;


inv_mat(Vartheta,Vartheta,2,&det);


/*bTheta=tausq_e*tX1ImWX2*(z-Xbeta)+WtWX2C2beta+c3Invm*/

bTheta[0]=0;bTheta[1]=0;

for(i=0;i<SIZE;i++){
bTheta[0]=bTheta[0]+tX1ImWX2[i]*(z[i]-w_s[i]-x[i]*beta_s[i]);
bTheta[1]=bTheta[1]+tX1ImWX2[i+SIZE]*(z[i]-w_s[i]-x[i]*beta_s[i]);
 }

bTheta[0]=bTheta[0]*tausq_e[k-1];
bTheta[1]=bTheta[1]*tausq_e[k-1];

/*(WX2)^\primeC2Inv=C2WX2^prime*/

	for(i=0;i<2*SIZE;i++){
bTheta[0]=bTheta[0]+C2WX2[2*i]*all_beta[i];
bTheta[1]=bTheta[1]+C2WX2[2*i+1]*all_beta[i];
	}
bTheta[0]=bTheta[0]+xi_m*tausq_w[k-1]*v0Inv;
bTheta[1]=bTheta[1]+beta_m*tausq_beta[k-1]*v1Inv;

  mat_mul(Vartheta,bTheta,mean_theta,2,2,1);


 sq_rt(Vartheta,sd_theta,2,&det);
   for(i=0;i<2;i++){ stdnormtheta[i]=nor_ran(0,1);}
   mat_mul(sd_theta,stdnormtheta,normtheta,2,2,1);
   add_mat(mean_theta,normtheta,2,1,theta);

/*
for(i=0;i<SIZE;i++){
printf("%.4f, ",w_s[i]);
}
printf("\n");
*/

xi_0[k]=theta[0];
beta_0[k]=theta[1];
/*
xi_0[k]=8.5;
beta_0[k]=-0.2;
*/
/*#######################################*/

/*tausq_w[k]=0;*/


 shape_w=(0.5*SIZE*T)+a_w+0.5;

 rowsum1=0;rowsum2=0;
  for(i=0;i<SIZE;i++){
	 for(j=0;j<SIZE;j++){
		 rowsum1=rowsum1+W[i*2*SIZE+j];
		 rowsum2=rowsum2+W[i*2*SIZE+(SIZE+j)];
	 }
 w_s_centred[i]=w_s[i]-rowsum1*xi_0[k]-rowsum2*beta_0[k];
	 rowsum1=0;rowsum2=0;
  }

 if(T>0){
 mat_mul(w_s_centred,Hphi_w_tInv,nbyTstore1,SIZE,T,T);
 trans_pose(nbyTstore1,Tbynstore1,SIZE,T);
 mat_mul(Hphi_w_sInv,w_s_centred,nbyTstore1,SIZE,SIZE,T);
 mat_mul(Tbynstore1,nbyTstore1,TbyTstore1,T,SIZE,T);
 wtHphi_wInvw=trace(TbyTstore1,T);
 }
 else{
  wtHphi_wInvw=xtAy(w_s_centred,Hphi_w_sInv,w_s_centred,SIZE);
 }

 rate_w=0.5*(wtHphi_wInvw+(sqr(xi_0[k]-xi_m)*v0Inv)+(2*b_w));

 tausq_w[k]=gam_ran(shape_w,1.0/(rate_w));
 /*
tausq_w[k]=1;
*/
 sigmasq_w=1.0/tausq_w[k];

 for(i=0;i<SIZE;i++){
for(j=0;j<SIZE;j++){
	S[i*SIZE+j]=sigmasq_w*Hphi_w_s[i*SIZE+j]+
		        (sigmasq_beta*x[i]*Hphi_beta_s[i*SIZE+j]*x[j]);
}}

for(i=0;i<SIZE;i++){
	S[i*SIZE+i]=S[i*SIZE+i]+sigmasq_e;
}


inv_mat(S,S,SIZE,&det);


for(i=0;i<SIZE;i++){
for(j=0;j<SIZE;j++){
C2X1t[i*SIZE+j]=sigmasq_w*Hphi_w_s[i*SIZE+j];
}}

for(i=SIZE;i<2*SIZE;i++){
for(j=0;j<SIZE;j++){
C2X1t[i*SIZE+j]=sigmasq_beta*Hphi_beta_s[(i-SIZE)*SIZE+j]*x[j];
}}

trans_pose(C2X1t,X1C2,2*SIZE,SIZE);

mat_mul(C2X1t,S,twonbynStore,2*SIZE*T,SIZE*T,SIZE*T);

for(i=0;i<2*SIZE;i++){
for(j=0;j<SIZE;j++){
W[i*SIZE*2+j]=twonbynStore[i*SIZE+j];
 }}

for(i=0;i<2*SIZE;i++){
for(j=SIZE;j<2*SIZE;j++){
W[i*SIZE*2+j]=twonbynStore[i*SIZE+(j-SIZE)]*x[(j-SIZE)];
 }}
/*#######################################*/

/*tausq_beta[k]=0;*/

 shape_beta=(0.5*SIZE*T)+a_beta+0.5;

 rowsum1=0; rowsum2=0;
 for(i=0;i<SIZE;i++){
	 for(j=0;j<SIZE;j++){
		 rowsum1=rowsum1+W[(i+SIZE)*2*SIZE+j];
		 rowsum2=rowsum2+W[(i+SIZE)*2*SIZE+(SIZE+j)];
	 }
 beta_s_centred[i]=beta_s[i]-rowsum1*xi_0[k]-rowsum2*beta_0[k];
	rowsum1=0; rowsum2=0;
 }

 if(T>0){
 mat_mul(beta_s_centred,Hphi_beta_tInv,nbyTstore2,SIZE,T,T);
 trans_pose(nbyTstore2,Tbynstore2,SIZE,T);
 mat_mul(Hphi_beta_sInv,beta_s_centred,nbyTstore2,SIZE,SIZE,T);
 mat_mul(Tbynstore2,nbyTstore2,TbyTstore1,T,SIZE,T);
 betatHphi_betaInvbeta=trace(TbyTstore1,T);
 }
 else{
 betatHphi_betaInvbeta=xtAy(beta_s_centred,Hphi_beta_sInv,beta_s_centred,SIZE);
 }

  rate_beta=0.5*(betatHphi_betaInvbeta+
         (sqr(beta_0[k]-beta_m)*v1Inv)+(2*b_beta));

 tausq_beta[k]=gam_ran(shape_beta,1.0/(rate_beta));

/*
tausq_beta[k]=3.0;
*/

 sigmasq_beta=1.0/tausq_beta[k];


  for(i=0;i<SIZE;i++){
for(j=0;j<SIZE;j++){
	S[i*SIZE+j]=sigmasq_w*Hphi_w_s[i*SIZE+j]+
		        (sigmasq_beta*x[i]*Hphi_beta_s[i*SIZE+j]*x[j]);
}}

for(i=0;i<SIZE;i++){
	S[i*SIZE+i]=S[i*SIZE+i]+sigmasq_e;
}


inv_mat(S,S,SIZE,&det);

for(i=0;i<SIZE;i++){
for(j=0;j<SIZE;j++){
C2X1t[i*SIZE+j]=sigmasq_w*Hphi_w_s[i*SIZE+j];
}}

for(i=SIZE;i<2*SIZE;i++){
for(j=0;j<SIZE;j++){
C2X1t[i*SIZE+j]=sigmasq_beta*Hphi_beta_s[(i-SIZE)*SIZE+j]*x[j];
}}

trans_pose(C2X1t,X1C2,2*SIZE,SIZE);

mat_mul(C2X1t,S,twonbynStore,2*SIZE*T,SIZE*T,SIZE*T);

for(i=0;i<2*SIZE;i++){
for(j=0;j<SIZE;j++){
W[i*SIZE*2+j]=twonbynStore[i*SIZE+j];
 }}

for(i=0;i<2*SIZE;i++){
for(j=SIZE;j<2*SIZE;j++){
W[i*SIZE*2+j]=twonbynStore[i*SIZE+(j-SIZE)]*x[(j-SIZE)];
 }}

/*#######################################*/
/*tausq_e*/

  shape_e=(0.5*SIZE*T)+a_e;

  rowsum1=0.0;rowsum2=0.0;rowsum3=0.0;rowsum4=0.0;

    for(i=0;i<SIZE*T;i++){
		 for(j=0;j<SIZE;j++){
rowsum1=rowsum1+W[i*SIZE*2+j];
rowsum2=rowsum2+W[i*SIZE*2+(j+SIZE)];
rowsum3=rowsum3+W[(i+SIZE)*SIZE*2+j];
rowsum4=rowsum4+W[(i+SIZE)*SIZE*2+(j+SIZE)];
		 }
		 z_mu[i]=z[i]-w_s[i]-beta_s[i]*x[i]-xi_0[k]-x[i]*beta_0[k]+
			   rowsum1*xi_0[k]+rowsum2*beta_0[k]+
			   x[i]*rowsum3*xi_0[k]+x[i]*rowsum4*beta_0[k];
   rowsum1=0.0;rowsum2=0.0;rowsum3=0.0;rowsum4=0.0;
  }

  sum_z_musq=0;
  for(i=0;i<SIZE*T;i++){
  sum_z_musq+=sqr(z_mu[i]);
  }
  rate_e=0.5*(sum_z_musq+(2*b_e));

  tausq_e[k]=gam_ran(shape_e,1.0/(rate_e));
  /*
  tausq_e[k]=3;
  */
  sigmasq_e=1.0/tausq_e[k];



/*#######################################*/



/*#######################################*/

/*z_0 has (N-m)*LOSIZE elements, the kth draw for the lth site is element k*LOSIZE+l*/

/*if(k>(M-1))*/
if(k>(M-1)){


 for(l=0;l<LOSIZE;l++){

   for(i=0;i<SIZE;i++){
    for(j=0;j<T;j++){

   S21_w[i*T+j]=(1.0/tausq_w[k])*exp(-phi_w_s*dist_0[i*LOSIZE+l]
                                     -phi_w_t*(T-j) );
                    }
                   }

   w_s_0=nor_ran(xi_0[k]+
                   tausq_w[k]*xtAy(S21_w,Hphi_w_sInv,w_s_centred,SIZE*T),
   sqrt((1.0/tausq_w[k])-tausq_w[k]*xtAy(S21_w,Hphi_w_sInv,S21_w,SIZE*T)));


  for(i=0;i<SIZE;i++){
     for(j=0;j<T;j++){
   S21_beta[i*T+j]=(1.0/tausq_beta[k])*exp(-phi_beta_s*
                       dist_0[i*LOSIZE+l]-phi_beta_t*(T-j));
                     }
                      }

    beta_s_0=nor_ran(beta_0[k]+
              tausq_beta[k]*xtAy(S21_beta,Hphi_beta_sInv,beta_s_centred,SIZE*T),
   sqrt((1.0/tausq_beta[k])-
          tausq_beta[k]*xtAy(S21_beta,Hphi_beta_sInv,S21_beta,SIZE*T)));

/*
printf("%.4f ",(1.0/tausq_w[k])-tausq_w[k]*xtAy(S21_w,Hphi_w_sInv,S21_w,SIZE*T));
printf("%.4f\n",(1.0/tausq_beta[k])-
          tausq_beta[k]*xtAy(S21_beta,Hphi_beta_sInv,S21_beta,SIZE*T));*/

   z_0[((k-M)*LOSIZE)+l]=sqr(nor_ran(w_s_0+beta_s_0*
                                    leave_out_x[l],pow(tausq_e[k],-0.5)));

                }/*end l loop*/
            }/*end if*/


/*Z_0=(N-m)xLOSIZE matrix, each column is a leave out site*/


/***************************************/
  } /*end k loop*/

end = clock();


/*estimates*/
for (i=M;i<N;i++){
sum_xi_0=sum_xi_0+xi_0[i];
sum_beta_0=sum_beta_0+beta_0[i];
sum_tausq_w= sum_tausq_w+(1.0/tausq_w[i]);
sum_tausq_beta=sum_tausq_beta+(1.0/tausq_beta[i]);
sum_tausq_e=sum_tausq_e+(1.0/tausq_e[i]);
}


/*store parameter estimates*/
xi_0_hat[r]=sum_xi_0/(N-M);
beta_0_hat[r]=sum_beta_0/(N-M);
tausq_w_hat[r]=sum_tausq_w/(N-M);
tausq_beta_hat[r]=sum_tausq_beta/(N-M);
tausq_e_hat[r]=sum_tausq_e/(N-M);

if(I>0){
/*each entry has the sum
of the draws from post.pred dist for each LO site*/
for(l=0;l<LOSIZE;l++){
for(i=0;i<(N-M);i++){
sum_z_0[l]+=z_0[i*LOSIZE+l];
                     }
                    }

/*estimate for z_0's*/
for(l=0;l<LOSIZE;l++){
z_0_hat[l]=(1.0/(N-M))*sum_z_0[l];
                     }

/*store REPS*LOSIZE z_0_hat*/
for(l=0;l<LOSIZE;l++){
store_z_0_hat[r*LOSIZE+l]=z_0_hat[l];
                     }

for(l=0;l<LOSIZE*I;l++){
      leave_out_z[l]=sqr(leave_out_z[l]);
                     }
}
/*********prediction error*********/
if(I>0){
for(l=0;l<LOSIZE;l++){
      sumSE+=sqr((leave_out_z[l]-z_0_hat[l]));
                     }
MSE=(1.0/LOSIZE)*sumSE;

for(l=0;l<LOSIZE;l++){
       sumAE+=fabs(leave_out_z[l]-(z_0_hat[l]));
                     }
MAE=(1.0/LOSIZE)*sumAE;

/*first term in crps*/

for(l=0;l<LOSIZE;l++){
    for(i=0;i<(N-M);i++){
diff[l]+=fabs(z_0[i*LOSIZE+l]-leave_out_z[l]);
                         }
diff[l]=(1.0/(N-M))*diff[l];
                     }

/*second term in crps, average of cross differences*/

for(l=0;l<LOSIZE;l++){
  for(j=0;j<(N-M);j++){
    for(k=0;k<(N-M);k++){
cross_diff[l]+=fabs(z_0[j*LOSIZE+l]-z_0[k*LOSIZE+l]) ;
                        }
                      }
cross_diff[l]=(1.0/(2*sqr(N-M)))*cross_diff[l];
                     }


for(l=0;l<LOSIZE;l++){
crps[l]=diff[l]-cross_diff[l];
}

for(l=0;l<LOSIZE;l++){
CRPS+=(1.0/(LOSIZE))*crps[l];}


store_MAE[r]=MAE;
store_MSE[r]=MSE;
store_CRPS[r]=CRPS;
}/*close if I>0*/

if(c==0){
par_output = fopen("par_output_f01_partSold.txt", "a+");
} else if(c==1){
par_output = fopen("par_output_f02_partSold.txt", "a+");
} else if (c==2){
par_output = fopen("par_output_f03_partSold.txt", "a+");
} else if (c==3){
par_output = fopen("par_output_f04_partSold.txt", "a+");
} else if (c==4){
par_output = fopen("par_output_f05_partSold.txt", "a+");
}


 for(i=0;i<N;i++){
     fprintf(par_output, "%f %f %f %f %f \n", xi_0[i],beta_0[i],tausq_w[i],tausq_beta[i],tausq_e[i]);
   }

 fclose(par_output);


pred_output = fopen("pred_output_f0_part.txt", "a+");

 for(i=0;i<((N-M)*LOSIZE*I);i++){
     fprintf(pred_output, "%f \n", z_0[i]);
   }

 fclose(pred_output);



}/*end r loop*/


time_spent = (double)(end - begin) / CLOCKS_PER_SEC;
printf("time: %.2f\n",time_spent);
printf("\n");
/*
printf("xi_0hat:");
for(r=0;r<REPS;r++){
printf(" %f, ",xi_0_hat[r]);}
printf("\n");

printf("beta_0hat:");
for(r=0;r<REPS;r++){
printf(" %f, ",beta_0_hat[r]);}
printf("\n");

printf("sigsq_what:");
for(r=0;r<REPS;r++){
printf(" %f, ",tausq_w_hat[r]);}
printf("\n");

printf("sigsq_betahat:");
for(r=0;r<REPS;r++){
printf(" %f, ",tausq_beta_hat[r]);}
printf("\n");

printf("sigsq_ehat:");
for(r=0;r<REPS;r++){
printf(" %f, ",tausq_e_hat[r]);}
printf("\n");

for(r=0;r<REPS;r++){
printf("%f, %f, %f, \n",store_MAE[r],store_MSE[r],store_CRPS[r] );
}
*/
/*
if(c==0){
accept_rates = fopen("ar_f01_partS.txt", "w");
} else if(c==1){
accept_rates = fopen("ar_f02_partS.txt", "w");
} else if (c==2){
accept_rates = fopen("ar_f03_partS.txt", "w");
} else if (c==3){
accept_rates = fopen("ar_f04_partS.txt", "w");
} else if (c==4){
accept_rates = fopen("ar_f05_partS.txt", "w");
}
*/

par_estimates = fopen("par_est_f0_partSold.txt", "w");

 for(i=0;i<REPS;i++){
     fprintf(par_estimates , "%f %f %f %f %f \n", xi_0_hat[i],beta_0_hat[i],tausq_w_hat[i],tausq_beta_hat[i],tausq_e_hat[i]);
   }

 fclose(par_estimates);

pred_estimates = fopen("pred_est_f0_part.txt", "w");

 for(i=0;i<(REPS*LOSIZE);i++){
     fprintf(pred_estimates, "%f \n", store_z_0_hat[i]);
   }

 fclose(pred_estimates);



pred_error = fopen("pred_error_f0_part.txt", "w");

 for(i=0;i<REPS;i++){
     fprintf(pred_error, "%f %f %f \n", store_MAE[i],store_MSE[i],
             store_CRPS[i]);
   }

 fclose(pred_error);


}/*close C loop*/
 return 0;
  }


/**********body of functions**************/

double min(double x,double y){
  double min=x;
  if (y<x){
    min=y;}
  return min;
  	 }

double sqr( x )
double x;
{
  return x * x;
}
/*random variates*/

/*uniform*/
double uni_ran()
{
 return ((double)rand() + 0.5)/((double)RAND_MAX + 1.0);
}

double nor_ran( u, s )
double u; double s;
{
  double t;
  t = sqrt( -2.0 * log( drand48()) )
 * cos( 2.0 * M_PI * drand48() );
  return u + s * t;
}

/* Berger's Gamma */
double gam_ran( a, be)
double a; double be;
{
  double b, c, w, u, v, x, z, y;
  int acc;                  /*  true = 1, false = 0 */
  double s,s1;

 if ( a<=1.0 )
 {
  s1 = gam_ran ( a + 1.0 , be );
  s = drand48();
  s =  pow ( s , 1.0 / a );
  s = s * s1;
 return s;
 }
 else
 {

  b = a-1.0; c = 3.0 * a - (3.0/4.0); acc = 0;
     do
     {
       u = drand48(); v = drand48();
       w = u * (1.0-u); y = sqrt(c/w) * (u-0.5); x = b+y;
       if (x >  0.0)
  {
      z = 64.0 * sqr(w) * w * sqr(v);
      if ( z < (1.0 - 2.0 * sqr(y) / x) )
        { acc = 1; }
      else if (log(z) < 2.0 * (b * log( x / b) - y))
       { acc = 1; }
  }
      } while( acc == 0 );

   return  x * be;

}

}


/*matrices*/


double trace(double *a, int p){
int i;  double u=0.0;

for (i=0; i<p; i++)
     u +=a[i*p+i];
return (u);
}


void add_mat(double *a, double *b, int n, int m, double *c) {
  int i, j;

  for (i=0; i<n; i++) {
      for (j=0; j<m; j++)
	c[i*m+j] = a[i*m+j]  + b[i*m+j];

}
}


void sub_mat(double *a, double *b, int n, int m, double *c) {
  int i, j;

  for (i=0; i<n; i++) {
      for (j=0; j<m; j++)
	c[i*m+j] = a[i*m+j]  - b[i*m+j];

}
}

double xtAy(x, A, y, p)
double *x;
double *A;
double *y;
int p;
{
 double u=0.0;
 int i, j;

 for (i=0; i<p; i++) {
   for (j=0; j<p; j++) {
     u +=x[i] * A[i*p+j] * y[j];
   }
 }
 return u;
 }


void trans_pose ( a, b, m, n )
double *a;
double *b;
int m;
int n;

{
 int i , j;

 for ( i = 0 ; i < m ; i++)
 {
  for ( j = 0 ; j < n ; j ++)
    {  b[j * m  + i]  = a[i * n  + j] ; }
  }

}


void tinv_mat ( t, c, p)
double *t;
double *c;
int p;

{
int i , j , k;
double u;

   for ( i = 0; i <p ; i++)
       {
         for ( j = 0;  j < p ; j++)
         c[i * p  + j] = 0.0;
       }

  for ( i = 0 ; i < p ; i++)
  c[i * p  + i] = 1.0 / t[i * p  + i];

 if ( p > 1) {
  c[p] = -t[p]* c[0]/ t[p + 1];

 for ( i=2 ; i <p ; i ++)
 {
  for ( j = 0 ; j < p-1  ; j ++)
  {
     if ( j < i ) {
      u = 0.0 ;
      for ( k = j ; k < i ; k++)
      u = u + t[i * p  + k] * c[k * p  + j];
      c[i * p  + j] = - u / t[i * p  + i];
     }
   }
 }
} /*  p  > 1 loop */

}



void inv_mat(S, inv, p, det)
double *S;
double *inv;
int p;
double *det;

{

double *t1; double *t; double u;

t1 =(double*)malloc(sizeof(double)*p*p);
t = (double*)malloc(sizeof(double)*p*p);

  sq_rt( S, t , p , &u);
  *det = u;
  tinv_mat( t , t1 , p);
  trans_pose(t1, t, p , p);
  mat_mul(t, t1, inv , p+0.0 , p+0.0 , p+0.0);
  *det = u;

free(t1);
free(t);
}



void sq_rt( a , t ,  p , det)
double *a;
double *t;
int     p;
double *det;

{

 int i , j , k ;
 double sum, sum1, u, v;

  for ( i = 0 ; i < p ; i ++)
      {
       for ( j = 0 ; j <p ; j++)
       t[i*p +j] = 0.0 ;
      }


  t[0] = sqrt(a[0]);
 if ( p > 1 ) {

  v = exp(-25.0);
  t[p] = a[p] / t[0];
  u =  a[p+1]  - sqr(t[p] );
  if  ( u<v ) {
         printf("Exited from sqrt: Matrix not pd\n");
         exit(19);
   } else  t[p+1] = sqrt(u);

  for (i=2 ; i<p ; i++)
    {
      t[i*p] =  a[i*p] /  t[0] ;
      for (j=1; j < p - 1 ; j++)
          {
            if ( j < i ) {
            sum1 = 0.0 ;
            for (k=0; k < j ; k++)
            sum1 += t[i*p + k] *  t[j*p + k];
            t[i*p+j] = (a[i*p + j]  - sum1) / t[j*p + j];
            }
          }

      sum = 0.0 ;
      for ( k = 0 ; k < i ; k ++)
      sum += sqr( t[i*p  + k] );
      u = a[i*p+i] - sum;
         if ( u<v ) {
                    printf("Exited from sqrt: Matrix not PD\n");
                    exit(19);
         } else  t[i*p+i] = sqrt(u);
    }

 } /* If loop for p > 1 */
 *det = 1.0 ;
 for ( i = 0 ; i < p ; i++)
 *det = *det * sqr( t[i*p + i] );

}

void mat_mul( ma1, ma2, mul, no, po, qo )
double *ma1; double *ma2; double *mul; double no; double po; double qo;
{



  int i, j, k, n, p, q;

  n = no; p = po; q = qo;

   for( i=0; i < n; i++)
   {
      for( j=0; j < q; j++)
      {  *(mul + i * q + j) = 0.0;   }
   }
   for( i=0; i < n; i++)
   {
       for( j=0; j < q; j++)
       {
           for( k=0; k < p; k++)
             *(mul + i * q + j) = *(mul + i * q + j) + *(ma1 + i * p + k) *
*(ma2 + k * q + j);
       }
   }
}


void scalar_mult(double s, double *x, int n, int m, double *ot)
{
  int i, j;

for (i=0; i<n; i++) {
  for (j=0; j<m; j++)
	ot[i*m+j] = x[i*m+j] * s;
}
}


double ludcmp(double *a, int n, int *indx, double *d)
{

        int i, imax, j, k;
        double big, dum, sum, temp;
        double *vv;

        vv =(double *)malloc(n * sizeof(double));

        for (i=0; i<n; i++)
            vv[i] = 0.0;

        *d =1.0;
        for (i=0; i<n; i++) {
            big=0.0;
            for (j=0; j<n; j++)
                if ( ( temp = fabs(a[i*n+j]) ) > big ) big = temp;
            if ( big==0.0) {
               printf("Singular matrix in routine ludcmp\n");
               exit(9);
            }
            vv[i] = 1.0/big;
        }
        for (j=0; j<n; j++) {
          for (i=0; i<j; i++) {
              sum = a[i*n+j];
              for (k=0; k<i; k++) sum -= a[i*n+k] * a[k*n+j];
              a[i*n+j] = sum;
          }
          big = 0.0;
for (i=j; i<n; i++) {
              sum = a[i*n+j];
              for (k=0; k<j; k++)
                  sum -= a[i*n+k] * a[k*n+j];
              a[i*n+j] = sum;
              if ( (dum=vv[i] * fabs(sum) ) >= big) {
                 big = dum;
                 imax = i;
              }
          }
          if (j !=imax) {
            for (k=0; k<n; k++) {
                dum = a[imax*n+k];
                a[imax*n+k] = a[j*n+k];
                a[j*n+k] = dum;
            }
            *d = - (*d);
            vv[imax] = vv[j];
          }
          indx[j] = imax;
          if (a[j*n+j] == 0.0) a[j*n+j] = TINY;
          if ( j!=n) {
             dum = 1.0/a[j*n+j];
             for (i=j+1; i<n; i++) a[i*n+j] *=dum;
          }
        }

        temp = *d;
        for (i=0; i<n; i++)  temp *=a[i*n+i];
        free(vv);
  return temp;
}
