
## Set the working directory in R to the data_files folder before executing the following R-code




library(coda)
MPSRF<-function(chain1,chain2,chain3,chain4,chain5){
N<-nrow(chain1)

W1<-matrix(NA,ncol(chain1),ncol(chain1))
W2<-matrix(NA,ncol(chain1),ncol(chain1))
W3<-matrix(NA,ncol(chain1),ncol(chain1))
W4<-matrix(NA,ncol(chain1),ncol(chain1))
W5<-matrix(NA,ncol(chain1),ncol(chain1))


for(i in 1:ncol(chain1)){
for(j in 1:ncol(chain1)){
W1[i,j]<-cov(chain1[,i],chain1[,j])
W2[i,j]<-cov(chain2[,i],chain2[,j])
W3[i,j]<-cov(chain3[,i],chain3[,j])
W4[i,j]<-cov(chain4[,i],chain4[,j])
W5[i,j]<-cov(chain5[,i],chain5[,j])
}}
W<-(1/5)*(W1+W2+W3+W4+W5)


means1<-apply(chain1,MARGIN=2,FUN=mean)
means2<-apply(chain2,MARGIN=2,FUN=mean)
means3<-apply(chain3,MARGIN=2,FUN=mean)
means4<-apply(chain4,MARGIN=2,FUN=mean)
means5<-apply(chain5,MARGIN=2,FUN=mean)

overallmeans<-c()
for (i in 1:length(means1)){
overallmeans[i]<-(1/5)*(means1[i]+means2[i]+
means3[i]+means4[i]+means5[i])
}

B1<-matrix(NA,ncol(chain1),ncol(chain1))
B2<-matrix(NA,ncol(chain1),ncol(chain1))
B3<-matrix(NA,ncol(chain1),ncol(chain1))
B4<-matrix(NA,ncol(chain1),ncol(chain1))
B5<-matrix(NA,ncol(chain1),ncol(chain1))


for(i in 1:ncol(chain1)){
for(j in 1:ncol(chain1)){
B1[i,j]<-(means1[i]-overallmeans[i])*(means1[j]-overallmeans[j])
B2[i,j]<-(means2[i]-overallmeans[i])*(means2[j]-overallmeans[j])
B3[i,j]<-(means3[i]-overallmeans[i])*(means3[j]-overallmeans[j])
B4[i,j]<-(means4[i]-overallmeans[i])*(means4[j]-overallmeans[j])
B5[i,j]<-(means5[i]-overallmeans[i])*(means5[j]-overallmeans[j])
}}
B<-(1/4)*(B1+B2+B3+B4+B5)

lambda<-eigen(solve(W)%*%B)$values[1]
msprf<-((N-1)/N)+1.2*lambda
return(msprf)
}



f01nc<-read.table("par_output_f01_nonS.txt") 
f02nc<-read.table("par_output_f02_nonS.txt") 
f03nc<-read.table("par_output_f03_nonS.txt") 
f04nc<-read.table("par_output_f04_nonS.txt") 
f05nc<-read.table("par_output_f05_nonS.txt") 


s<-3
f01nc[,2:s]<-1/f01nc[,2:s]
f02nc[,2:s]<-1/f02nc[,2:s]
f03nc[,2:s]<-1/f03nc[,2:s]
f04nc[,2:s]<-1/f04nc[,2:s]
f05nc[,2:s]<-1/f05nc[,2:s]
N<-25000
reps<-400
interval<-5

threshold<-c()
distancef0nc<-c()
ESS<-matrix(NA,reps,s)

for(r in 1:reps){
index<-interval*(1:(N/interval))
yf0nc<-c()
for (i in 1:(N/interval)){
yf0nc[i]<-MPSRF(chain1=f01nc[((r-1)*N)+(1:index[i]),1:s],
chain2=f02nc[((r-1)*N)+(1:index[i]),1:s],chain3=f03nc[((r-1)*N)+(1:index[i]),1:s],
chain4=f04nc[((r-1)*N)+(1:index[i]),1:s],chain5=f05nc[((r-1)*N)+(1:index[i]),1:s])
if(as.numeric(yf0nc[i])<1.1)break
}
threshold[r]<-length(yf0nc)*interval


f0nc<-mcmc.list(mcmc(f01nc[((r-1)*N)+(1:N),]),mcmc(f02nc[((r-1)*N)+(1:N),]),
mcmc(f03nc[((r-1)*N)+(1:N),]),mcmc(f04nc[((r-1)*N)+(1:N),]),
mcmc(f05nc[((r-1)*N)+(1:N),]))

ESS[r,]<-effectiveSize(f0nc)
}

testsf0nc<-cbind("threshold"=threshold,"ESS theta"=ESS[,1],"ESS sig0"=ESS[,2],"ESS sige"=ESS[,3])

write.table(testsf0nc,"testsf0nc_2.txt")


